package com.engine.nbkq.service.impl;

import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.engine.nbkq.po.GenerateDocParams;
import com.engine.nbkq.service.NbkqService;
import com.engine.nbkq.util.CommonDateUtil;
import com.engine.nbkq.util.FileOperateUtil;
import com.engine.nbkq.util.WorkflowCreateHandlerUtil;
import com.engine.workflow.service.HtmlToPdfService;
import com.engine.workflow.service.impl.HtmlToPdfServiceImpl;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.GCONST;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.soa.workflow.request.RequestInfo;
import weaver.soa.workflow.request.RequestService;

import java.io.File;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 签字意见按钮接口
 * Created by dengjp on 2021/9/6.
 */
public class NbkqServiceImpl extends Service implements NbkqService {



    /**
     * 创建契约锁预入职流程
     * @param params
     * @return
     */
    @Override
    public Map<String, Object> createYrzBatch(Map<String, Object> params) {
        Map<String,Object> resutl = new HashMap<String,Object>();
        Map<String,Object> backPath = new HashMap<>();
        BaseBean bb = new BaseBean();
        bb.writeLog("createYrzBatch ==>");
        RecordSet rs = new RecordSet();
        RecordSet rsUpdate = new RecordSet();
        String reqid = "-1";
        String IsNextFlow = "0";
        Integer docid = 0;
        DateTimeFormatter dateFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        LocalDateTime localDateTime = LocalDateTime.now();
        String curDate = localDateTime.format(dateFormatter);
        WorkflowCreateHandlerUtil workflowCreateHandler = new WorkflowCreateHandlerUtil();

        try {
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            //预入职流程id
            String yrzWfid = bb.getPropValue("nbkq_main","yrzWfid");
            //固定流程创建人
            String lccjr = bb.getPropValue("nbkq_main","lccjr");
            String wid = "";
            String sfzh = Util.null2String(params.get("sfzh"));
            wid = yrzWfid;
            bb.writeLog("sfzh:"+sfzh);
            String name  = resourceComInfo.getLastname(lccjr);
            // 获取请求标题
            String title = "";
            String workflowName = "预入职契约锁自动审批-EHR";
            title = workflowName+"-"+name+"-"+curDate;
            bb.writeLog("title:"+title);
            Map<String,String> requestMap = new HashMap<String,String>();
            String sql = " select id,sqzw,tbrq,xm,xb,csrq,sfzh,mz,jg,byyx,zy,hklx,zc,tc,csd,xhkszd,zwtg,bm,rzrq,syqx,sygz,zzgz,zp,xlxdz,\n" +
                    " lxdh,sg,zzmm,cjgzsj,hyzk,xl,zjcx,xx,jjlxr,jjlxrdh,sfzfj,yxkfj,xlfj,qtfj,ywflqys,wjfqfqys　\n" +
                    " from　uf_yrzbd where sfzh = '"+sfzh+"' order by modedatacreatedate desc,modedatacreatetime desc";
            rs.executeQuery(sql);
            if(rs.next()){
                String id = Util.null2String(rs.getString("id"));
                String sqzw = Util.null2String(rs.getString("sqzw"));
                String tbrq = Util.null2String(rs.getString("tbrq"));
                String xm = Util.null2String(rs.getString("xm"));
                String xb = Util.null2String(rs.getString("xb"));
                String csrq = Util.null2String(rs.getString("csrq"));
                String sfzhNew = Util.null2String(rs.getString("sfzh"));
                String mz = Util.null2String(rs.getString("mz"));
                String jg = Util.null2String(rs.getString("jg"));
                String byyx = Util.null2String(rs.getString("byyx"));
                String zy = Util.null2String(rs.getString("zy"));
                String hklx = Util.null2String(rs.getString("hklx"));
                String zc = Util.null2String(rs.getString("zc"));
                String tc = Util.null2String(rs.getString("tc"));
                String csd = Util.null2String(rs.getString("csd"));
                String xhkszd = Util.null2String(rs.getString("xhkszd"));
                String zwtg = Util.null2String(rs.getString("zwtg"));
                String bm = Util.null2String(rs.getString("bm"));
                String rzrq = Util.null2String(rs.getString("rzrq"));
                String syqx = Util.null2String(rs.getString("syqx"));
                String sygz = Util.null2String(rs.getString("sygz"));
                String zzgz = Util.null2String(rs.getString("zzgz"));
                String zp = Util.null2String(rs.getString("zp"));
                String xlxdz = Util.null2String(rs.getString("xlxdz"));
                String lxdh = Util.null2String(rs.getString("lxdh"));
                String sg = Util.null2String(rs.getString("sg"));
                String zzmm = Util.null2String(rs.getString("zzmm"));
                String cjgzsj = Util.null2String(rs.getString("cjgzsj"));
                String hyzk = Util.null2String(rs.getString("hyzk"));
                String xl = Util.null2String(rs.getString("xl"));
                String zjcx = Util.null2String(rs.getString("zjcx"));
                String xx = Util.null2String(rs.getString("xx"));
                String jjlxr = Util.null2String(rs.getString("jjlxr"));
                String jjlxrdh = Util.null2String(rs.getString("jjlxrdh"));
                String sfzfj = Util.null2String(rs.getString("sfzfj"));
                String yxkfj = Util.null2String(rs.getString("yxkfj"));
                String xlfj = Util.null2String(rs.getString("xlfj"));
                String qtfj = Util.null2String(rs.getString("qtfj"));
                String ywflqys = Util.null2String(rs.getString("ywflqys"));
                String wjfqfqys = Util.null2String(rs.getString("wjfqfqys"));

                //删除同身份证号历史数据
                deleteById(id,sfzh);

                if(StringUtils.isNotBlank(sqzw)){
                    requestMap.put("sqzw",sqzw);
                }
                if(StringUtils.isNotBlank(tbrq)){
                    requestMap.put("tbrq",tbrq);
                }
                if(StringUtils.isNotBlank(xm)){
                    requestMap.put("xm",xm);
                }
                if(StringUtils.isNotBlank(xb)){
                    requestMap.put("xb",xb);
                }
                if(StringUtils.isNotBlank(csrq)){
                    requestMap.put("csrq",csrq);
                }
                if(StringUtils.isNotBlank(sfzhNew)){
                    requestMap.put("sfzh",sfzhNew);
                }
                if(StringUtils.isNotBlank(mz)){
                    requestMap.put("mz",mz);
                }
                if(StringUtils.isNotBlank(jg)){
                    requestMap.put("jg",jg);
                }
                if(StringUtils.isNotBlank(byyx)){
                    requestMap.put("byyx",byyx);
                }
                if(StringUtils.isNotBlank(zy)){
                    requestMap.put("zy",zy);
                }
                if(StringUtils.isNotBlank(hklx)){
                    requestMap.put("hklx1",hklx);
                }
                if(StringUtils.isNotBlank(zc)){
                    requestMap.put("zc",zc);
                }
                if(StringUtils.isNotBlank(tc)){
                    requestMap.put("tc",tc);
                }
                if(StringUtils.isNotBlank(csd)){
                    requestMap.put("csd",csd);
                }
                if(StringUtils.isNotBlank(xhkszd)){
                    requestMap.put("xhkszd",xhkszd);
                }
                if(StringUtils.isNotBlank(zwtg)){
                    requestMap.put("zwtg",zwtg);
                }
                if(StringUtils.isNotBlank(bm)){
                    requestMap.put("bm",bm);
                }
                if(StringUtils.isNotBlank(rzrq)){
                    requestMap.put("rzrq",rzrq);
                }
                if(StringUtils.isNotBlank(syqx)){
                    requestMap.put("syqx",syqx);
                }
                if(StringUtils.isNotBlank(sygz)){
                    requestMap.put("sygz",sygz);
                }
                if(StringUtils.isNotBlank(zzgz)) {
                    requestMap.put("zzgz", zzgz);
                }
                if(StringUtils.isNotBlank(zp)) {
                    requestMap.put("zp", zp);
                }
                if(StringUtils.isNotBlank(xlxdz)) {
                    requestMap.put("xlxdz", xlxdz);
                }
                if(StringUtils.isNotBlank(lxdh)) {
                    requestMap.put("lxdh", lxdh);
                }
                if(StringUtils.isNotBlank(sg)) {
                    requestMap.put("sg", sg);
                }
                if(StringUtils.isNotBlank(zzmm)) {
                    requestMap.put("zzmr", zzmm);
                }
                if(StringUtils.isNotBlank(cjgzsj)) {
                    requestMap.put("cjgzsj", cjgzsj);
                }
                if(StringUtils.isNotBlank(hyzk)) {
                    requestMap.put("hyzk", hyzk);
                }
                if(StringUtils.isNotBlank(xl)) {
                    requestMap.put("xl", xl);
                }
                if(StringUtils.isNotBlank(zjcx)) {
                    requestMap.put("zjcx", zjcx);
                }
                if(StringUtils.isNotBlank(xx)) {
                    requestMap.put("xx", xx);
                }
                if(StringUtils.isNotBlank(jjlxr)) {
                    requestMap.put("jjlxr", jjlxr);
                }
                if(StringUtils.isNotBlank(jjlxrdh)) {
                    requestMap.put("jjlxrdh", jjlxrdh);
                }
                if(StringUtils.isNotBlank(sfzfj)) {
                    requestMap.put("sfzfj", sfzfj);
                }
                if(StringUtils.isNotBlank(yxkfj)) {
                    requestMap.put("yxkfj", yxkfj);
                }
                if(StringUtils.isNotBlank(xlfj)) {
                    requestMap.put("xlfj", xlfj);
                }
                if(StringUtils.isNotBlank(qtfj)) {
                    requestMap.put("qtfj", qtfj);
                }
                if(StringUtils.isNotBlank(ywflqys)) {
                    requestMap.put("ywflqys", ywflqys);
                }
                if(StringUtils.isNotBlank(wjfqfqys)) {
                    requestMap.put("wjfqfqys", wjfqfqys);
                }


                reqid = workflowCreateHandler.WorkflowCreateByRequestMap(lccjr,wid, title, IsNextFlow, requestMap);

                if(Util.getIntValue(reqid) > 0){
                    bb.writeLog("流程主表创建成功:"+title);
                    bb.writeLog("开始处理明细");
                    //明细表1处理
                    List<Map<String,String>> list = new ArrayList<Map<String,String>>();
                    String sqlDt1 = " select ksrq,jsrq,xx,zy,bz,zmr,lxdh from uf_yrzbd_dt1 where mainid = "+id;
                    rs.executeQuery(sqlDt1);
                    while (rs.next()){
                        Map<String,String> mapMode = new HashMap<>();
                        String ksrq = Util.null2String(rs.getString("ksrq"));
                        String jsrq = Util.null2String(rs.getString("jsrq"));
                        String xxNew = Util.null2String(rs.getString("xx"));
                        String zyNew = Util.null2String(rs.getString("zy"));
                        String bz = Util.null2String(rs.getString("bz"));
                        String zmr = Util.null2String(rs.getString("zmr"));
                        String lxdhDto = Util.null2String(rs.getString("lxdh"));
                        if (StringUtils.isNotBlank(ksrq)){
                            mapMode.put("ksrq",ksrq);
                        }
                        if (StringUtils.isNotBlank(jsrq)){
                            mapMode.put("jsrq",jsrq);
                        }
                        if (StringUtils.isNotBlank(xxNew)){
                            mapMode.put("xx",xxNew);
                        }
                        if (StringUtils.isNotBlank(zyNew)){
                            mapMode.put("zy",zyNew);
                        }
                        if (StringUtils.isNotBlank(bz)){
                            mapMode.put("bz",bz);
                        }
                        if (StringUtils.isNotBlank(zmr)){
                            mapMode.put("zmr",zmr);
                        }
                        if (StringUtils.isNotBlank(lxdhDto)){
                            mapMode.put("lxdh",lxdhDto);
                        }
                        list.add(mapMode);
                    }

                    String tablename = workflowCreateHandler.findWorkflowForm(wid);
                    String mainid = "" ;
                    if(!"".equals(tablename))
                    {
                        String dt1 = " select id from "+tablename+" where requestid="+reqid;
                        bb.writeLog("sql："+dt1);
                        rs.execute(dt1);
                        if(rs.next())
                        {
                            mainid = Util.null2String(rs.getString("id"));
                        }
                        bb.writeLog("mainid："+mainid);
                        String tablenameDt1 = tablename + "_dt1";
                        String mess = insertTableDt(Util.getIntValue(reqid),list,tablenameDt1,mainid);
                        bb.writeLog("mess："+mess);
                        if("0".equals(mess))
                        {
                            bb.writeLog("明细表1处理完成");
                        }else{
                            bb.writeLog("明细表1处理失败");
                        }
                    }

                    //明细表2处理
                    List<Map<String,String>> list2 = new ArrayList<Map<String,String>>();
                    String sqlDt2 = " select ksrq,jsrq,gzdw,zw,lzyy,zmr,xz,lxdh from uf_yrzbd_dt2 where mainid = "+id;
                    rs.executeQuery(sqlDt2);
                    while (rs.next()){
                        Map<String,String> mapMode = new HashMap<>();
                        String ksrq = Util.null2String(rs.getString("ksrq"));
                        String jsrq = Util.null2String(rs.getString("jsrq"));
                        String gzdw = Util.null2String(rs.getString("gzdw"));
                        String zw = Util.null2String(rs.getString("zw"));
                        String lzyy = Util.null2String(rs.getString("lzyy"));
                        String zmr = Util.null2String(rs.getString("zmr"));
                        String xz = Util.null2String(rs.getString("xz"));
                        String lxdhDtT = Util.null2String(rs.getString("lxdh"));
                        if (StringUtils.isNotBlank(ksrq)){
                            mapMode.put("ksrq",ksrq);
                        }
                        if (StringUtils.isNotBlank(jsrq)){
                            mapMode.put("jsrq",jsrq);
                        }
                        if (StringUtils.isNotBlank(gzdw)){
                            mapMode.put("gzdw",gzdw);
                        }
                        if (StringUtils.isNotBlank(zw)){
                            mapMode.put("zw",zw);
                        }
                        if (StringUtils.isNotBlank(lzyy)){
                            mapMode.put("lzyy",lzyy);
                        }
                        if (StringUtils.isNotBlank(zmr)){
                            mapMode.put("zmr",zmr);
                        }
                        if (StringUtils.isNotBlank(xz)){
                            mapMode.put("xz",xz);
                        }
                        if (StringUtils.isNotBlank(lxdhDtT)){
                            mapMode.put("lxdh",lxdhDtT);
                        }
                        list2.add(mapMode);
                    }


                    if(!"".equals(tablename))
                    {
                        String tablenameDt2 = tablename + "_dt2";
                        String mess = insertTableDt(Util.getIntValue(reqid),list2,tablenameDt2,mainid);
                        bb.writeLog("mess："+mess);
                        if("0".equals(mess))
                        {
                            bb.writeLog("明细表2处理完成");
                        }else{
                            bb.writeLog("明细表2处理失败");
                        }
                    }

                    //明细表3处理
                    List<Map<String,String>> list3 = new ArrayList<Map<String,String>>();
                    String sqlDt3 = " select xm,nl,ybrgx,zz,zy,lxdh from uf_yrzbd_dt3 where mainid = "+id;
                    rs.executeQuery(sqlDt3);
                    while (rs.next()){
                        Map<String,String> mapMode = new HashMap<>();
                        String xmNew = Util.null2String(rs.getString("xm"));
                        String nl = Util.null2String(rs.getString("nl"));
                        String ybrgx = Util.null2String(rs.getString("ybrgx"));
                        String zz = Util.null2String(rs.getString("zz"));
                        String zyNew = Util.null2String(rs.getString("zy"));
                        String lxdhDtTh = Util.null2String(rs.getString("lxdh"));

                        if (StringUtils.isNotBlank(xmNew)){
                            mapMode.put("xm",xmNew);
                        }
                        if (StringUtils.isNotBlank(nl)){
                            mapMode.put("nl",nl);
                        }
                        if (StringUtils.isNotBlank(ybrgx)){
                            mapMode.put("ybrgx",ybrgx);
                        }
                        if (StringUtils.isNotBlank(zz)){
                            mapMode.put("zz",zz);
                        }
                        if (StringUtils.isNotBlank(zyNew)){
                            mapMode.put("zy",zyNew);
                        }
                        if (StringUtils.isNotBlank(lxdhDtTh)){
                            mapMode.put("lxdh",lxdhDtTh);
                        }
                        list3.add(mapMode);
                    }


                    if(!"".equals(tablename))
                    {
                        String tablenameDt3 = tablename + "_dt3";
                        String mess = insertTableDt(Util.getIntValue(reqid),list3,tablenameDt3,mainid);
                        bb.writeLog("mess："+mess);
                        if("0".equals(mess))
                        {
                            bb.writeLog("明细表3处理完成");
                        }else{
                            bb.writeLog("明细表3处理失败");
                        }
                    }
                    //将表单内容生成PDF
                    Map<String,Object> paramsPdf = new HashMap<>();
                    long currentTimeMillis = System.currentTimeMillis();
                    String outPutPath = GCONST.getRootPath() + "hrm" + File.separator + "import" + File.separator + "template" + File.separator + "resume" + File.separator;
                    paramsPdf.put("requestid",reqid);
                    paramsPdf.put("onlyHtml","0");
                    paramsPdf.put("pageSize",100);
                    paramsPdf.put("path",outPutPath);
                    paramsPdf.put("filename","预入职信息"+currentTimeMillis);
                    paramsPdf.put("keepsign","1");
                    paramsPdf.put("limitauth","0");
                    paramsPdf.put("src","");
                    paramsPdf.put("modeid","");
                    paramsPdf.put("useWk","1");

                    User userLcc = new User(Integer.valueOf(lccjr));
                    HtmlToPdfService htmlToPdfService = (HtmlToPdfService) ServiceUtil.getService(HtmlToPdfServiceImpl.class,userLcc);
                    backPath = (htmlToPdfService != null) ? htmlToPdfService.getFormDatas(paramsPdf) : new HashMap<>();
                    String fileName =  backPath.get("filename").toString();
                    String outpath = outPutPath + File.separator + new File(fileName);

                    //固定流程创建人
                    String secid = bb.getPropValue("nbkq_main","secid");
                    //附件生成
                    int imageFileid = FileOperateUtil.generateImageFileid(outpath, fileName);
                    //文档生成
                    GenerateDocParams generateDocParams = GenerateDocParams.builder()
                            .imageFileid(imageFileid)
                            .fileName(fileName)
                            .creater(Integer.valueOf(lccjr))
                            .docCreateDate(CommonDateUtil.getFormatLocalDate(LocalDateTime.now()))
                            .docCreateTime(CommonDateUtil.getLocalTimeStr())
                            .maincategory(0)
                            .subcategory(0)
                            .seccategory(Integer.valueOf(secid))
                            .docType(2)
                            .docExtendname(".pdf")
                            .build();
                    docid = FileOperateUtil.generateDocId(userLcc,generateDocParams);

                    String updateFj = " update "+tablename+" set scfj = '"+docid+"' where requestid = "+reqid;
                    rsUpdate.executeUpdate(updateFj);
                    //将流程扭转至下一节点
                    RequestService requestService = new RequestService();
                    RequestInfo requestInfo = requestService.getRequest(Integer.parseInt(reqid));
                    requestService.nextNodeBySubmit(requestInfo,Integer.parseInt(reqid),Integer.valueOf(lccjr),"");
                }
            }
            resutl.put("code","200");
            resutl.put("msg","创建成功");
            resutl.put("reqid",reqid);
            resutl.put("backPath",backPath);
            resutl.put("docid",docid);

        }catch (Exception e) {
            bb.writeLog("createStaffApplyBatch Exception: "+e);
            resutl.put("code","500");
            resutl.put("msg","接口异常");
            return resutl;
        }
        return resutl;
    }

    /**
     * 删除同身份证号历史数据
     * @param id
     * @param sfzh
     */
    public static void deleteById(String id,String sfzh){
        RecordSet rs = new RecordSet();
        String deleteSql = "delete from uf_yrzbd where sfzh = '"+sfzh+"' and id != "+id;
        rs.executeUpdate(deleteSql);
    }


    /***
     *
     *
     * @param ireqid
     * @param detailList
     * @return
     */
    public String insertTableDt(int ireqid, List<Map<String,String>> detailList, String tableDtName, String dataid)
    {
        BaseBean bb = new BaseBean();
        String message = "0" ;
//		WorkflowCreateHandler workflowCreateHandler = new WorkflowCreateHandler();
        //获取表单名称
//		String tablename = workflowCreateHandler.findWorkflowForm(WorkFlowId);
        //String dataid = workflowCreateHandler.findDataIDByReqID(WorkFlowId, ireqid+"");
        if(!"".equals(dataid) && dataid !=null)
        {
            RecordSet rs = new RecordSet();
            //插入明细表
//            String tablename_dt1 = tableDtName;		//明细表名
            for(Map<String,String> detailMap : detailList)
            {
                String dttablename = "" ;
                String dttablenvalue = "" ;
                for (Map.Entry<String, String> entry : detailMap.entrySet())
                {
                    String fieldname = Util.null2String(entry.getKey());
                    String fieldvalue = Util.null2String(entry.getValue());
                    dttablename += dttablename==""? fieldname :","+fieldname ;
                    dttablenvalue += dttablenvalue=="" ? "'"+fieldvalue+"'" :",'"+fieldvalue+"'" ;
                }
                bb.writeLog("dttablename:"+dttablename);
                bb.writeLog("dttablenvalue:"+dttablenvalue);
                if(dttablename !="" && dttablenvalue !="")
                {
                    String sql = "insert into "+tableDtName+" (mainid,"+dttablename+") values ("+dataid+","+dttablenvalue+")";
                    bb.writeLog(sql);
                    boolean boo = rs.execute(sql);
                    if(!boo)
                    {
                        message = "-1" ;
                    }
                }else{
                    message = "-2" ;
                }
            }
        }else{
            message = "-3" ;
        }
        return message;
    }
}