package weaver.email ;

/*
 * @(#)VerifyMailLogin.java	1.4 00/05/24
 *
 * Copyright 2002 Weaver, Inc. All Rights Reserved.
 *
 */

import java.io.File;
import java.io.Writer;
import java.net.Socket;
import java.security.Security;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.mail.Address;
import javax.mail.AuthenticationFailedException;
import javax.mail.Flags;
import javax.mail.Folder;
import javax.mail.Header;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.URLName;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.servlet.http.HttpServletRequest;

import net.sf.json.JSONObject;
import oracle.sql.CLOB;
import weaver.conn.ConnStatement;
import weaver.conn.RecordSet;
import weaver.email.service.MailResourceFileService;
import weaver.email.service.MailResourceService;
import weaver.general.BaseBean;
import weaver.general.GCONST;
import weaver.general.StaticObj;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.system.SysRemindWorkflow;
import weaver.systeminfo.SystemEnv;

import com.caucho.quercus.lib.spl.Iterator;
import com.sun.mail.imap.IMAPFolder;
import com.sun.mail.pop3.POP3Folder;
import com.sun.net.ssl.internal.ssl.Provider;

public class WeavermailUtil extends BaseBean{
    
    private String username ;
    private String userpassword ;

    private String emailAccountId = null;//邮箱发送账号
    private String emailAccountPassword = null;//邮箱发送密码
    

	private SysRemindWorkflow sysRemindWorkflow = new SysRemindWorkflow();
	
    public String getUsername() {
        return username ;
    }

    public String getUserPassword() {
        return userpassword ;
    }


    public void getUserMailInfo (int userid) {
        RecordSet rs = new RecordSet() ;
        rs.executeProc("MailPassword_SByResourceid",""+userid) ;
        if(rs.next()) {
            username = Util.null2String(rs.getString("resourcemail")) ;
            userpassword = Util.null2String(rs.getString("password")) ;
        }
    }

    public void saveMailinfo(int userid , String username , String password ) {
        RecordSet rs = new RecordSet() ;
        char separator = Util.getSeparator() ;
        String para = "" + userid + separator + username + separator + password ;
        rs.executeProc("MailPassword_IByResourceid",para) ;
    }

    public void removeUserMailInfo(int userid) {
        RecordSet rs = new RecordSet() ;
        String sql = " delete from MailPassword where  resourceid = " + userid ;
        rs.executeSql(sql) ;
    }
    
    public synchronized boolean fetchFolder( Folder folder , boolean needopen ,  int openmode ) {
        try {
            if( folder != null && folder.isOpen() ) folder.close(true) ;
            if( needopen ) {
                folder.open( openmode ) ;
            }
        }catch(Exception es){ 
            forseCloseStore ( folder ) ;
            writeLog(es) ;
            return false ;
        }
        return true ;
    }


    public void closeStore( Store store ) {
        try {
            if( store != null && store.isConnected() ) store.close() ;
        }catch(Exception es){writeLog(es) ; }
    }

    public void forseCloseStore( Store store ) {
        try {
            if( store != null ) store.close() ;
            store = null ;
        }catch(Exception es){writeLog(es) ; }
    }

    public void forseCloseStore( Folder folder ) {
        try {
            Store store = folder.getStore() ;
            if( store != null ) store.close() ;
            store = null ;
        }catch(Exception es){writeLog(es) ; }
    }


	/**
	 *
	 */
	public void updateMailAccountReceivedInfo(int mailAccountId){
		Hashtable hashTbl = new Hashtable();
		RecordSet rs = new RecordSet();
		RecordSet rs2 = new RecordSet();
		String sql = "";
		String maxSendDate = "";
		String sendFrom = "";
		
		//查找以前该帐户收取过的发件人
		sql = "SELECT * FROM MailAccountReceivedInfo WHERE accountId="+mailAccountId+"";
		rs.executeSql(sql);
		while(rs.next()){
			hashTbl.put(rs.getString("sendfrom"), rs.getString("receivedDateTime"));
		}
		//查找当前该帐户所有邮件的发件人
		sql = "SELECT MAX(senddate) AS maxSendDate, sendfrom FROM MailResource WHERE  mailAccountId="+mailAccountId+" GROUP BY sendfrom";
		rs.executeSql(sql);
		while(rs.next()){
			maxSendDate = rs.getString("maxSendDate");
			sendFrom = rs.getString("sendfrom");

			//判断该发件人的邮件以前是否收取过
			if(hashTbl.containsKey(sendFrom)){//以前收过该发件人的邮件
				if(TimeUtil.timeInterval((String)hashTbl.get(sendFrom), maxSendDate) > 0){//如果大于历史记录，则更新最后收取时间
					sql = "UPDATE MailAccountReceivedInfo SET receivedDateTime='"+maxSendDate+"' WHERE accountId="+mailAccountId+" AND sendfrom='"+sendFrom+"'";
				    rs2.executeSql(sql);	
				}
			}else{//以前没收过该发件人的邮件，插入一条记录保存最后收取时间
				sql = "INSERT INTO MailAccountReceivedInfo VALUES ("+mailAccountId+", '"+maxSendDate+"', '"+sendFrom+"')";
				rs2.executeSql(sql);	
			}
					
		}
	}

	/**
	 * 获得邮件真是发送地址
	 * @param m
	 * @return
	 */	
	public String getRealeSendfrom(Message m){
		
		String realesendfrom = "" ;
		try {
			try{
				Address[] fr =  m.getFrom();
				if (fr != null) {
					for (int i = 0; i < fr.length; i++) {
						realesendfrom  += (i==0 ? "" : ",") + ((InternetAddress)fr[i]).getAddress() ;
					}
				}
				realesendfrom=new String(realesendfrom.getBytes("ISO8859_1"),"UTF-8") ; 
			}catch(javax.mail.internet.AddressException addressException){
				Enumeration headers = m.getAllHeaders() ;
				String headerFrom="";
				while(headers.hasMoreElements()){
					Header h= (Header) headers.nextElement() ;
	                String headername = Util.null2String( h.getName() ) ;
					if((headername.toLowerCase()).equals("from")) {
						headerFrom = h.getValue();
	                }
				}
				realesendfrom=new String(headerFrom.getBytes("ISO8859_1"),"UTF-8");
			} 
		} catch (Exception e) {
			writeLog(this.getClass());
			writeLog(e);
			e.printStackTrace();
		}
		
		return realesendfrom;
	}
	
	/**
	 * 获得邮件发送日期
	 * @param m
	 * @return
	 */
	public String getSenddate(Message m){ 
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String senddate="";
		try {
			if(m.getSentDate()!=null) senddate=df.format(m.getSentDate()) ;
	        else if(m.getReceivedDate()!=null) senddate=df.format(m.getReceivedDate());
	        else senddate=df.format(new Date()); 
		} catch (Exception e) {
			writeLog(this.getClass());
			writeLog(e);
			e.printStackTrace();
		}
		
		return senddate;
	}
	
	public String getMailContent(int mailid,String userid,HttpServletRequest request){
		MailResourceService mrs=new MailResourceService();
		MailResourceFileService mrfs=new MailResourceFileService();
		//读取邮件，并加载到缓存中
		mrs.setId(mailid+"");
		mrs.setResourceid(userid);
		mrs.selectMailResource();
		mrs.next();
		//EML
		String _emlPath = Util.null2String(mrs.getEmlpath());
		String emlName = Util.null2String(mrs.getEmlname());
		String emlPath = GCONST.getRootPath() + "email" + File.separatorChar + "eml" + File.separatorChar;
		File eml = new File(emlPath + emlName + ".eml");
		if(!_emlPath.equals("")) eml = new File(_emlPath);
		
		String mailContent= mrs.getContent();
		if(mrs.getHashtmlimage().equals("1")){
			mrfs.selectMailResourceFileInfos(mailid+"","0");
			while(mrfs.next()){
				
				int imgId = mrfs.getId();
				String thecontentid = mrfs.getFilecontentid();
				String oldsrc = "cid:" + thecontentid ;
				String newsrc = "http://"+Util.getRequestHost(request)+"/weaver/weaver.email.FileDownloadLocation?fileid="+imgId;
				mailContent = Util.StringReplaceOnce(mailContent , oldsrc , newsrc ) ;
			}
		}
		try {
			mailContent = Util.replace(mailContent, "==br==", "\n", 0);
		} catch (Exception e) {
			e.printStackTrace();
			writeLog(e);
		}
		
		return mailContent;
	}
	
	/**
	 * 获得邮件地址的用户名 例如：xxx@xxx.com 的用户名为：张三
	 * @param mailAddress
	 * @return
	 */
	public String getEmailRealName(String mailAddress,String userid,boolean isHasSuffix){
		String realName=""; 
		try {
			ResourceComInfo resourceComInfo=new ResourceComInfo();
			realName=resourceComInfo.getLastnameByEmail(mailAddress); //查询人力资源
			String sql="";
			RecordSet rs=new RecordSet();
			if(realName.equals("")){
				sql="select mailUserName from MailUserAddress where mailAddress ='"+mailAddress+"'"+(userid.equals("")?"":" and userid="+userid); //查询联系人 
				rs.execute(sql);
				if(rs.next()){
					realName=rs.getString("mailUserName"); 
				}
			}
			if(realName.equals("")){
				sql="SELECT accountName FROM MailAccount WHERE accountMailAddress='"+mailAddress+"'";
				rs.execute(sql);
				if(rs.next())
					realName=rs.getString("accountName");
				else{
				    realName=mailAddress;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(!isHasSuffix&&realName.indexOf("@")!=-1)
			realName=realName.substring(0,realName.indexOf("@"));
		realName=realName.replace(",", "");
		return realName;
	}
	
	public Map receiveMailNumber(int mailAccountId,String userid){
		
		int flag=0;
		Map result=new HashMap();
		StaticObj staticobj = StaticObj.getInstance();
		String mailReceiveAccountidListKey="mailReceiveAccountids_"+userid+"_key"; //用于存贮每个用户当前正在接收的邮件账户
		ArrayList receiveAccountidList=new ArrayList();
		
		//将正在接收的邮件账户id放入静态类中，接收完成后移除，目的是防止重复接收
		if(staticobj.getObject(mailReceiveAccountidListKey)!=null){
			receiveAccountidList=(ArrayList)staticobj.getObject(mailReceiveAccountidListKey);
			if(receiveAccountidList.contains("mailAccountid_"+mailAccountId)){
			   flag=1; //正在接收邮件
			   result.put("flag", flag);
			   result.put("number", 0);
			   return result;
			}else{
			   receiveAccountidList.add("mailAccountid_"+mailAccountId);
			   staticobj.putObject(mailReceiveAccountidListKey,receiveAccountidList);
			}   
		}else{
			receiveAccountidList.add("mailAccountid_"+mailAccountId);
			staticobj.putObject(mailReceiveAccountidListKey,receiveAccountidList);
		}
		
		RecordSet rs=new RecordSet();
		
		String sql = "";
		String mailReceivedDateTime = "";
		long secondInterval = 0;
		long nowInterval = 0;
		String sendfrom = "";
		String senddate = "";
		
		HashMap displayname = new HashMap();
		BaseBean b=new BaseBean();
		sql = "select * from MailUserAddress where userid = '"+userid+"'";
		rs.executeSql(sql);
		while(rs.next()){
			displayname.put(rs.getString("mailaddress"),rs.getString("mailusername"));
		}
		
		String accountReceivedInfo = buildAccountReceivedInfo(mailAccountId).toString(); //之前接受的邮件信息值

		Store store = null;
		Folder folder = null;
		int receivedMailNumber = 0;
		int receivedMailId = 0;

		Hashtable hashTbl = new Hashtable();
		//查找以前该帐户收取过的发件人
		sql = "SELECT * FROM MailAccountReceivedInfo WHERE accountId="+mailAccountId+"";
		rs.executeSql(sql);
		while(rs.next()){
			hashTbl.put(rs.getString("sendfrom"), rs.getString("receivedDateTime"));
		}

		try{
			store=getStore(mailAccountId);
			folder = store.getDefaultFolder();
			folder = folder.getFolder("INBOX");
			folder.open(Folder.READ_ONLY);
			
			Weavermail weavermail=new Weavermail();
			
			Message message[] = folder.getMessages();
			String messageReceivedDateTime = "";
			String currentDate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
			for(int i=message.length-1; i>=0; i--){
				weavermail.setUserid(userid);
				weavermail.setDisplayname(displayname);
				WeavermailComInfo wmc;
				Message m=message[i];
				sendfrom=getRealeSendfrom(m);
				senddate=getSenddate(m);
				//之前接收过该收件人的邮件
				if(hashTbl.containsKey(sendfrom)){
					mailReceivedDateTime = (String)hashTbl.get(sendfrom);
					secondInterval = TimeUtil.timeInterval(senddate, mailReceivedDateTime);
					nowInterval = TimeUtil.timeInterval(senddate,currentDate);
					
					if(nowInterval<0) continue;//发送时间应该小于当前接收时间，目前主要用于过滤垃圾邮件
					if(secondInterval<0){
						//TODO Refactor
						if(accountReceivedInfo.indexOf(sendfrom+senddate)!=-1) continue;
						receivedMailNumber++;
					}else{
						//判断邮件是否为按照时间，顺序接收，防止顺序接收后跳出,一般邮件都是按照时间倒序
						if(i>0){
							String senddate2=getSenddate(message[i-1]); 
							if(TimeUtil.timeInterval(senddate, senddate2)>0){continue;}else{break;}
						}
					}
				}else{//之前没有接收过该收件人的邮件

					if(accountReceivedInfo.indexOf(sendfrom+senddate)!=-1) continue;
					receivedMailNumber++;
				}

			}
			
		}catch(AuthenticationFailedException e){
			b.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
			b.writeLog(e);
			e.printStackTrace();
		}catch(MessagingException e){
			b.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
			b.writeLog(e);
			e.printStackTrace();
		}catch(Exception e){
			b.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
			b.writeLog(e);
			e.printStackTrace();
		}finally{
			try {
				if(folder!=null){folder.close(false);}
				if(store!=null){store.close();}
			} catch (Exception e) {
				b.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
				b.writeLog(e);
				e.printStackTrace();
			}
			//从静态类中将正在接收的账户id移除
			receiveAccountidList.remove("mailAccountid_"+mailAccountId);
			staticobj.putObject(mailReceiveAccountidListKey,receiveAccountidList);
		}
		
		result.put("flag", flag);
		result.put("number", receivedMailNumber);
		return result;
	}
	
	private Store getStore(int mailAccountId){
		RecordSet rs=new RecordSet();
		
		String  accountId="", accountPassword="",  popServer="", smtpServer="",  protocol="";
		String encryption="";
		String needSSL = "";
		String popServerPort = "";
		
		String sql = "SELECT * FROM MailAccount WHERE id="+mailAccountId+"";
		rs.executeSql(sql);
		if(rs.next()){
			accountId = rs.getString("accountId");
			accountPassword = rs.getString("accountPassword");
			popServer = rs.getString("popServer");
			smtpServer = rs.getString("smtpServer");
			
			popServerPort = rs.getString("popServerPort");
			needSSL = rs.getString("getneedSSL");
			protocol = rs.getString("serverType").equals("1") ? "pop3" : "imap";
			encryption = rs.getString("encryption");
		}
		if(encryption.equals("1")) accountPassword = EmailEncoder.DecoderPassword(accountPassword);
		
		Store store = null;
		Properties props = new Properties() ;
		javax.mail.Session s = null;
		
		try{
			if(needSSL.equals("1")){
				  Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider()); 

				  // Get a Properties object 
				  props.setProperty("mail."+protocol+".socketFactory.class", "javax.net.ssl.SSLSocketFactory"); 
				  props.setProperty("mail."+protocol+".socketFactory.fallback", "false"); 
				  props.setProperty("mail."+protocol+".port", popServerPort); 
				  props.setProperty("mail."+protocol+".socketFactory.port", popServerPort); 
				  //props.setProperty("mail."+protocol+".starttls.enable","true");
				  
				  //以下步骤跟一般的JavaMail操作相同 
				   s = Session.getDefaultInstance(props,null);

				  //请将红色部分对应替换成你的邮箱帐号和密码 
				  URLName urln = new URLName(protocol,popServer,Integer.parseInt(popServerPort),null, 
						  accountId, accountPassword); 
				  store = s.getStore(urln); 
				  store.connect();
			}else{
				props.put("mail.smtp.smtphost", smtpServer);
				props.put("mail.transport.protocol", "smtp");
				props.put("mail."+protocol+".port", String.valueOf(popServerPort));

				s = javax.mail.Session.getInstance(props, null);
				store = s.getStore(protocol);
				store.connect(popServer, accountId, accountPassword);
			}
		}catch (Exception e) {
			// TODO: handle exception
		}
		return store;
	}
	
	
	StringBuffer buildAccountReceivedInfo(int accountId){
		StringBuffer str = new StringBuffer();
		weaver.conn.RecordSet rs = new weaver.conn.RecordSet();
		rs.executeSql("SELECT sendfrom,senddate FROM MailResource WHERE size_n>0 and mailAccountId="+accountId+"");
		while(rs.next()){
			str.append(rs.getString("sendfrom")+rs.getString("senddate")+",");
		}
		return str;
	}
	/**
	 * 检查邮件是否收取过
	 * @param sendfrom   邮件发送人
	 * @param senddate   邮件发送时间
	 * @return 已经接收过就返回true，否则false
	 */
	public boolean  checkMailIsExist(String sendfrom,String senddate,int mailAccountId,String messageid){
		boolean isExist=false; 
		if ((messageid == null) || ("null".equals(messageid)) || ("".equals(messageid))) {
		      messageid = "0";
		}
		String sql=" SELECT sendfrom,senddate,messageid FROM MailResource " +
				   " where mailAccountId= " + mailAccountId +
				   " and (messageid='" + messageid + "' or (messageid = '0' and sendfrom='" + sendfrom + "' and senddate='" + senddate + "')) " + 
				   " and folderid<>-1 "; 
		RecordSet recordSet=new RecordSet();
		recordSet.execute(sql);
		if(recordSet.next()) 
			isExist=true;
		return isExist;
	}
	
	/**
	 * 检查发件人是否存在于该用户的黑名单中
	 * @param sendmail 发件人
	 * @return isBlacklist 是否存在黑名单中
	 */
	public boolean checkMailBlackList(String sendmail, User user) {
		boolean isBlacklist = false;
		if(sendmail.indexOf('@') == -1)
			return isBlacklist;
		
		String postfix = sendmail.substring(sendmail.indexOf('@')+1, sendmail.length());
		String sql = " select id from MailBlacklist where userid = '" + user.getUID() + "' and (name = '" + sendmail + "' or postfix = '" + postfix + "') ";
		RecordSet recordSet=new RecordSet();
		recordSet.execute(sql);
		if(recordSet.next()) 
			isBlacklist=true;
		return isBlacklist;
	}

	
	public String getAccInfo(String fileid,User user) {
		if(null != fileid && !"".equals(fileid)){
			RecordSet rs = new RecordSet();
			rs.execute("select * from MailResourceFile  where id in ("+fileid+")");
			StringBuffer sb = new StringBuffer();
			String ids=",";
			while (rs.next()) {
				ids+=rs.getString("id")+",";
				float size = rs.getFloat("filesize")/1024;
				String size_str;
				if(size == 0 ){
					size_str = "1.00 KB";
				}else if(size>511){
					size_str = String.format("%.2f",size/1024)+" MB";
				}else{
					size_str = String.format("%.2f",size+1)+" KB";
				}
				
				sb.append("<div id='"+rs.getString("id")+"' class=''>");
				sb.append("<div class='left m-t-3' style='background: url(/email/images/mailicon_wev8.png) -65px 0px  no-repeat ;width: 16px;height: 16px;'>&nbsp;</div>");
				sb.append("<div class='left fileName p-b-3'  >"+rs.getString("filename")+"</div>");
				sb.append("<div class='left fileSize p-l-5' >("+size_str+")<input type='hidden' name='fileSize' value='"+Math.round(rs.getInt("filesize")/1024)+"</div>");
				sb.append("<div class='left p-l-5'  >&nbsp;&nbsp;&nbsp;&nbsp;<span style='color:green !important'>上传完成</span></div>");
				sb.append("<div class='left p-l-15' ><a class='del'  href='#' onclick='javascript:doDelAcc("+rs.getString("id")+")'>"+SystemEnv.getHtmlLabelName(91, user.getLanguage())+"</a></div>");
				sb.append("<div class='clear'></div>");
				sb.append("</div>");
			}
			return sb.toString();
		}
		return "";
	}
	
	public String receiveMail(int mailAccountId,User user,HttpServletRequest request) {
		return receiveMail(mailAccountId, user, request, false);
		
	}
	
	/**
	 * 
	 * @param mailAccountId 邮件主键值
	 * @return
	 */
	public String receiveMail(int mailAccountId,User user,HttpServletRequest request, boolean isremind){
		JSONObject json = new JSONObject();
		RecordSet rs = new RecordSet();
		Store store = null;
		Folder folder = null;
		boolean folderExpunge = false;
		String userid=""+user.getUID();
		
		Weavermail weavermail = new Weavermail();
		try{
			
			//设置联系人信息
			HashMap displayname = new HashMap();
			rs.executeSql("select * from MailUserAddress where userid = '"+user.getUID()+"'");
			while(rs.next()){
				displayname.put(rs.getString("mailaddress"),rs.getString("mailusername"));
			}
			weavermail.setUserid(user.getUID()+"");
			weavermail.setDisplayname(displayname);
			
			//查找以前该帐户收取过的发件人
			Hashtable receiveInfoTab = new Hashtable();
			rs.executeSql("SELECT * FROM MailAccountReceivedInfo WHERE accountId="+mailAccountId+"");
			while(rs.next()){
				receiveInfoTab.put(rs.getString("sendfrom"), rs.getString("receivedDateTime"));
			}
			
			//获取当前接受邮箱账号信息【如果receiveScope没有设定接收时间范围，默认接收所有邮件 receiveScope 1为最近一个月，2为最近三个月，3为最近半年，4为最近一年，5为全部】
			rs.executeSql("SELECT needSave ,receiveScope ,receiveDateScope, lasttime FROM MailAccount WHERE id="+mailAccountId);
			rs.next();
			String lasttime = rs.getString("lasttime");
			//接收时间间隔判断
			if(!(lasttime == null || "".equals(lasttime))) {
				Date lastDate = TimeUtil.getString2Date(lasttime, "yyyy-MM-dd HH:mm:ss");
				if(new Date().getTime() - lastDate.getTime()<60000){
					json.put("receivedMailNumber", "0");
					return json.toString();
				}
			}
			//更新接收时间
			RecordSet rs2 = new RecordSet();
			rs2.executeSql("update MailAccount set lasttime = '"+TimeUtil.getCurrentTimeString()+"' WHERE id="+mailAccountId);
			String needSave = rs.getString("needSave");
			folderExpunge = needSave.equals("1")?false:true;
			int receiveScope= Util.getIntValue(rs.getString("receiveScope"),5);
			String receiveDateScope = rs.getString("receiveDateScope")+" 00:00:00";

			String receivedMailIds = "";
			String remindMailids = "";
			int receivedMailNumber = 0;
			String currentDate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());
			
			List<List<String>> blackList=getMailBlackList(userid);
			String blackMailids="";
			
			store = this.getMailStore(mailAccountId+"");
			
			folder = store.getDefaultFolder();
			folder = folder.getFolder("INBOX");
			if(folderExpunge){
				folder.open(Folder.READ_WRITE);
			}else{
				folder.open(Folder.READ_ONLY);
			}
				
			Message messages[] = folder.getMessages();
			for(int i=messages.length-1; i>=0; i--){
				Message message=(MimeMessage)messages[i];
				String sendfrom=this.getRealeSendfrom(message);
				String senddate=this.getSenddate(message);
				String messageid = this.getMessageid(message);
				
				
					
//				if(1==1){
//					if(senddate.equals("2005-02-04 14:15:43")){
//						messages[i].setFlag(Flags.Flag.DELETED, true);
//					}
//					continue;
//				}
				
				if(receiveInfoTab.containsKey(sendfrom)){//之前接收过该收件人的邮件
					String mailReceivedDateTime = (String)receiveInfoTab.get(sendfrom);
					long secondInterval = TimeUtil.timeInterval(senddate, mailReceivedDateTime);
					long nowInterval = TimeUtil.timeInterval(senddate,currentDate);
					
					if(nowInterval<0) continue;//发送时间应该小于当前接收时间，目前主要用于过滤垃圾邮件
					if(receiveScope != 5 && TimeUtil.timeInterval(senddate,receiveDateScope)>0){//当设置了时间过滤时候，发送时间应该晚于设定的时间
						continue;
					}
					
					if(secondInterval<0){
						if(this.checkMailIsExist(sendfrom, senddate,mailAccountId, messageid)) continue; //检查邮件是否接收过
						WeavermailComInfo wmc = weavermail.parseMail(messages[i], true);
						if(wmc==null) continue;
						int receivedMailId = weavermail.saveMail(messages[i], wmc, user, wmc.getContenttype(), mailAccountId);
						this.respondEmail(receivedMailId,user.getUID()); //自动回复
						
						if(receivedMailId>0){ //如果邮件已经收取过会返回0
							receivedMailNumber++;
							receivedMailIds += String.valueOf(receivedMailId) + ",";
							if(checkMailBlackList(sendfrom,blackList)){
								blackMailids+=receivedMailId + ",";
							}
						}
					}else{
						//判断邮件是否为按照时间，顺序接收，防止顺序接收后跳出,一般邮件都是按照时间倒序
						if(i>0){
							String senddate2=this.getSenddate(messages[i-1]); 
							if(TimeUtil.timeInterval(senddate, senddate2)>0){continue;}else{break;}
						}
					}
				}else{//之前没有接收过该收件人的邮件
					if(receiveScope != 5 && TimeUtil.timeInterval(senddate,receiveDateScope)>0){//当设置了时间过滤时候，发送时间应该晚于设定的时间
							continue;
					}
					if(this.checkMailIsExist(sendfrom, senddate,mailAccountId, messageid)) continue; //检查邮件是否接收过
					WeavermailComInfo wmc = weavermail.parseMail(messages[i], true);
					if(wmc==null) continue;
					int receivedMailId = weavermail.saveMail(messages[i], wmc, user, wmc.getContenttype(), mailAccountId);
					
					this.respondEmail(receivedMailId,user.getUID());  //自动回复
					if(receivedMailId>0){ //如果邮件已经收取过会返回0
						receivedMailNumber++;
						receivedMailIds += String.valueOf(receivedMailId) + ",";
						if(checkMailBlackList(sendfrom,blackList)){
							blackMailids+=receivedMailId + ",";
						}else{
							remindMailids+=receivedMailId + ",";
						}
					}
				}
				if(folderExpunge) messages[i].setFlag(Flags.Flag.DELETED, true);

			}
				
			if(receivedMailNumber>0){ //有新邮件才更新最后收取时间
				this.updateMailAccountReceivedInfo(mailAccountId);
			}
			
			if(blackMailids.length()>0){ //有新邮件才更新最后收取时间
				this.updateMailAccountReceivedInfo(mailAccountId);
			}
			
			if(!receivedMailIds.equals("")){
				MailRule rule = new MailRule();
				rule.apply(receivedMailIds, user, mailAccountId, request, "0");
			}
			
			if(isremind) {
				
				//邮件到达提醒
				new Thread(new MailArriveRemind(remindMailids,"0")).start();
			}
			
			//黑名单处理
			moveMailtoDustbin(blackMailids);
			
			/*
			//消息提醒
			if(!receivedMailIds.equals("")){
				if(receivedMailIds.endsWith(",")) receivedMailIds=receivedMailIds.substring(0, receivedMailIds.length()-1);
				String sql =  "insert into SysPoppupRemindInfoNew (userid,ifpup,usertype,type,requestid,reminddate,counts) " +
					"select resourceid,1,0,15,id,'',1 from mailresource where id in ("+receivedMailIds+")";
				rs.execute(sql);
			}
			*/
			
			json.put("receivedMailNumber", receivedMailNumber);
		}catch(Exception e){
			e.printStackTrace();
//			if(e.getClass().getName().equals("javax.mail.AuthenticationFailedException")){//账号验证失败
//				updateReceiveAccount(mailAccountId,user,false);
//			}
			
			this.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
			this.writeLog(e);
			
			MailErrorMessageInfo errinfo = new MailErrorFormat(e).getMailErrorMessageInfo();
			errinfo.setMailaccid(mailAccountId+"");
			json.put("receivedMailNumber", "-1");
			json.put("msg",errinfo );
		}finally{
			try {
				if(folder!=null){folder.close(folderExpunge);}
				if(store!=null){store.close();}
			} catch (Exception e) {
				this.writeLog("邮件接收错误:"+e.toString()+":"+e.getMessage());
				this.writeLog(e);
			}
		}
//		if(!json.get("receivedMailNumber").equals("-1"))   //如果成功接收清除错误累计次数
//			updateReceiveAccount(mailAccountId,user,true);
		return json.toString();
		
	}
	
	/**
	 * 更新处理接收账户信息，接收成功清除错误累计次数，接收失败累计错误次数累计7次失败则更新状态不在自动收取
	 * @param mailAccountId
	 * @param user
	 * @param result
	 */
	public void updateReceiveAccount(int mailAccountId,User user,boolean result ) {
		RecordSet rs = new RecordSet();
		try {
			if(result) {
				rs.execute("update MailAccount set  errorCount = 0 where id = "+mailAccountId);   //接收成功清除错误累计次数
			}else {
				String today = TimeUtil.getToday();
				rs.execute("select accountName,receiveStatus,autoReceivetime from MailAccount where id = "+mailAccountId);
				rs.next();
				int errorCount = rs.getInt("errorCount");
				String errorCountset = "";
				if(errorCount < 0)errorCount = 0;
				if(rs.getInt("receiveStatus") == 1 && !today.equals(rs.getString("autoReceivetime"))){
					errorCount++;
					sysRemindWorkflow.setSysRemindInfo("邮件定时接收失败，请检查邮箱账号设置", 0, 0, 0, 0, 1, user.getUID()+"", "请检查【"+rs.getString("accountName")+"】邮箱账户设置是否有误!");
					if(errorCount >= 7)
						errorCountset = " receiveStatus = 0, ";
					rs.execute("update MailAccount set "+errorCountset+" autoReceivetime = '"+today+"', errorCount = "+errorCount+" where id = "+mailAccountId);//将邮件接收状态更改为0
				}
			}
			
		} catch (Exception exception) {
			this.writeLog(exception);
		}		
	}
	
	
	/**
	 * 根据传入的账号主键值，获取对应邮件的message信息
	 * @return
	 */
	public Store getMailStore(String mailAccountId) throws Exception{
		Store store = null;
		RecordSet rs = new RecordSet();
		rs.execute("select * from MailAccount where id = "+mailAccountId);
		if(rs.getCounts() !=1){
			return null;
		}
		rs.next();
		String accountId = rs.getString("accountId");
		String accountPassword = rs.getString("accountPassword");
		String popServer = rs.getString("popServer");
		String smtpServer = rs.getString("smtpServer");
		
		String popServerPort = rs.getString("popServerPort");
		String needSSL = rs.getString("getneedSSL");
		String protocol = rs.getString("serverType").equals("1") ? "pop3" : "imap";
		String encryption = rs.getString("encryption");
		
		Socket socket = new Socket(popServer , Util.getIntValue(popServerPort));
		if(socket.isConnected()){
			socket.close();
		}
		
		if(encryption.equals("1")) accountPassword = EmailEncoder.DecoderPassword(accountPassword);
		Properties props = new Properties() ;
		if(needSSL.equals("1")){
			  Security.addProvider(new Provider()); 
			  String SSL_FACTORY = "javax.net.ssl.SSLSocketFactory"; 

			  // Get a Properties object 
			  props.setProperty("mail."+protocol+".socketFactory.class", SSL_FACTORY); 
			  props.setProperty("mail."+protocol+".socketFactory.fallback", "false"); 
			  props.setProperty("mail."+protocol+".port", popServerPort); 
			  props.setProperty("mail."+protocol+".socketFactory.port", popServerPort); 

			  //以下步骤跟一般的JavaMail操作相同 
			  Session session = Session.getDefaultInstance(props,null);

			  //请将红色部分对应替换成你的邮箱帐号和密码 
			  URLName urln = new URLName(protocol,popServer,Integer.parseInt(popServerPort),null, 
					  accountId, accountPassword); 
			  store = session.getStore(urln); 
			  store.connect();
		}else{
			props.put("mail.smtp.smtphost", smtpServer);
			props.put("mail.transport.protocol", "smtp");
			Session session = Session.getInstance(props, null);
			store = session.getStore(protocol);
			store.connect(popServer, accountId, accountPassword);
		}
		
		return store; 
	}
	
	
	
	/**
	 * 自动进行邮箱回复
	 * @param receivedMailId 接受邮件存储的主键值
	 */
	public void respondEmail(int receivedMailId,int userid){
		
		try {
			RecordSet rs = new RecordSet();
			boolean needRespond = false;
			String content = "";
			String contactAddress = ",";
			int isContactReply = 0; //是否只是回复联系人中的邮箱 【0为回复所有邮箱】【1为回复联系人中的邮箱】
			
			rs.execute("select * from MailAutoRespond where userId = "+userid);
			if(rs.next()){
				needRespond = rs.getInt("isAuto")==1?true:false;
				
				content = rs.getString("content");
				isContactReply = rs.getInt("isContactReply");
				
				if(needRespond&&1 == isContactReply){//濡傛灉闇€瑕佸鎴峰惎鐢ㄤ簡锛屽彧鍥炲鑱旂郴浜洪偖浠跺姛鑳斤紝鏌ョ湅鑱旂郴浜轰俊鎭?
					rs.execute("SELECT mailaddress FROM MailUserAddress WHERE userId ="+userid);
					while(rs.next()){
						contactAddress += rs.getString("mailaddress")+",";
					}
				}
			}
			
			if(!needRespond)return;
			
			RecordSet rt = new RecordSet();
			rt.execute("SELECT * FROM MailResource WHERE id = '"+receivedMailId+"'");
			rt.first();
			
			String sendto = rt.getString("sendfrom");
			if(rt.getString("subject").startsWith("自动回复:"))return;
			//如果只回复联系人中的邮件，且当前收件人不在联系人列表中，则直接返回
			if(isContactReply == 1 && !contactAddress.contains(","+sendto+",")){
				return;
			}
			
			//获取邮件回复邮件内容+邮件标题
			
			
			int resourceid = rt.getInt("resourceid");
			String sendfrom = rt.getString("sendto");
			String subject = "自动回复:"+rt.getString("subject");
			
		
	        Calendar today = Calendar.getInstance();
	        String senddate = Util.add0(today.get(Calendar.YEAR), 4) +"-"+
	                          Util.add0(today.get(Calendar.MONTH) + 1, 2) +"-"+
	                          Util.add0(today.get(Calendar.DAY_OF_MONTH), 2) + " " +
	                          Util.add0(today.get(Calendar.HOUR_OF_DAY), 2) + ":" +
	                          Util.add0(today.get(Calendar.MINUTE), 2) + ":" +
	                          Util.add0(today.get(Calendar.SECOND), 2) ;
			
			
			String priority = "3";
			String _mailAccountId = rt.getString("mailAccountId");
			String _status = "1";
			String _folderId = "-1";
			String texttype="";
			
			//先保存发件箱中的邮件信息
	        char separator = Util.getSeparator() ; 
	        int mailid = 0;
	        if(rt.getDBType().equals("oracle")){
	        	String para = "" + resourceid + separator + priority + separator +
	                sendfrom + separator + "" + separator + "" + separator +
	                sendto + separator + senddate + separator + "" + separator +
	                subject + separator + ""  + separator +texttype + separator +"" + 
					separator + _mailAccountId + separator + _status + separator + _folderId;
	        	rt.executeProc("MailResource_Insert",para) ;
	        	//得到最新的邮件的id
	            if(rt.next()) mailid = rt.getInt(1);
				String sql = "insert into MailContent (mailid, mailcontent) values(?,empty_clob()) ";
				ConnStatement statement = new ConnStatement();
				statement.setStatementSql(sql);
				statement.setInt(1, mailid);
				statement.executeUpdate();
				sql = "select mailcontent from MailContent where mailid = "+mailid +" for update";
				statement.setStatementSql(sql, false);
				statement.executeQuery();
				statement.next();
				CLOB theclob = statement.getClob(1);
				String doccontenttemp = content;
				char[] contentchar = doccontenttemp.toCharArray();
				Writer contentwrite = theclob.getCharacterOutputStream();
				contentwrite.write(contentchar);
				contentwrite.flush();
				contentwrite.close();
				statement.close();
	        }else{
	        	
	        String para = "" + resourceid + separator + priority + separator +
	                sendfrom + separator + "" + separator + "" + separator +
	                sendto + separator + senddate + separator + "" + separator +
	                subject + separator + content  + separator +texttype + separator + "" + 
					separator + _mailAccountId + separator + _status + separator + _folderId;
	        	   rt.executeProc("MailResource_Insert",para) ; 
	        	   //得到最新的邮件的id
	                if(rt.next()) mailid = rt.getInt(1) ;
	        }
				
	        //进行邮件发送
	        MailSend mailSend = new MailSend();
	        boolean sendstatus = mailSend.sendMailByMailid(mailid);
	        
	        //邮件发送失败，保存到草稿箱
	        if(!sendstatus){
	        	RecordSet draftst = new RecordSet();
	        	draftst.execute("update  mailresource set folderId='-2' , canview=1  where  id='"+mailid+"'");
	        }else{//发送成功，则影藏掉
	        	RecordSet draftst = new RecordSet();
	        	draftst.execute("update  mailresource set  canview=1  where  id='"+mailid+"'");
	        }

		} catch (Exception e) {
			this.writeLog(e);
		}
		
	}
	
	/**
	 * 获取邮件 UID
	 * 
	 */
	public static String getMessageid(Message message) throws Exception{
		String messageid ="";
		Folder folder=message.getFolder();
		try {
			if (folder instanceof POP3Folder) {
				POP3Folder inbox = (POP3Folder) folder;
				messageid = inbox.getUID(message);
			}else if(folder instanceof IMAPFolder){
				IMAPFolder inbox = (IMAPFolder) folder;
				messageid = Long.toString(inbox.getUID(message));
			}
		} catch (Exception e) {
			e.printStackTrace();
			return messageid;
		}
		return messageid;
	}
	
	public List<List<String>> getMailBlackList(String userid) {
		
		List<List<String>> blackList=new ArrayList<List<String>>();
		List<String> addressList = new ArrayList<String>();
		List<String> postfixList = new ArrayList<String>();
		String sql = "select * from MailBlacklist where userid = '" + userid + "'";
		RecordSet recordSet=new RecordSet();
		recordSet.execute(sql);
		while(recordSet.next()){
			String address=Util.null2String(recordSet.getString("name"));
			String postfix=Util.null2String(recordSet.getString("postfix"));
			if(!address.equals("")){
				addressList.add(address);
			}else{
				postfixList.add(postfix);
			}
		}
		blackList.add(addressList);
		blackList.add(postfixList);
		return blackList;
	}
	/**
	 * 检查发件人是否存在于该用户的黑名单中
	 * @param sendfrom
	 * @param blackList
	 * @return
	 */
	public boolean checkMailBlackList(String sendfrom, List<List<String>> blackList) {
		boolean isBlacklist = false;
		if(sendfrom.indexOf('@') == -1)
			return isBlacklist;
		
		String postfix = sendfrom.substring(sendfrom.indexOf('@')+1, sendfrom.length());
		List<String> addressList = blackList.get(0);
		List<String> postfixList = blackList.get(1);
		for(String mailaddr : addressList) {
			if(mailaddr.indexOf(sendfrom) != -1)
				return true;
		}
		
		for(String postfixblack : postfixList) {
			if(postfixblack.indexOf(postfix) != -1)
				return true;
		}
		return isBlacklist;
	}
	
	/**
	 * 移动到垃圾箱
	 * @param mailid
	 */
	public void moveMailtoDustbin(String mailids) {
		if(mailids.length() == 0)
			return;
		
		if(mailids.endsWith(","))
			mailids = mailids.substring(0, mailids.length() - 1);
		
		String sql = " update MailResource set folderId = -3 where id in ("+mailids+")";
		RecordSet recordSet=new RecordSet();
		recordSet.execute(sql);
	}
	
	/**
	 * 解决字符串中，前面，中间，后面多余的逗号，返回左右无逗号的字符串
	 * 如：",,,,2,3" 输出 2,3
	 * 如：",,,,2,,3" 输出 2,3
	 * 如：",,,,2,3,,,,," 输出 2,3
	 * 如：",,2,,3,," 输出 2,3
	 * @param str
	 * @return
	 */
	public static String trim(String str) {
			String returnstr="";
			String sz[]=str.split(",");
			for(int i=0;i<sz.length;i++){
				if(!"".equals(sz[i])){//主要用于排查字符串中的多个逗号的情况如：（3，，4，，，6，）
					returnstr+=sz[i]+",";
				}
			}
			int len = returnstr.length();
			int st = 0;
			int off = 0;
			char[] val = returnstr.toCharArray();
			while ((st < len) && (val[off + st] <= ',')) {
			st++;
			}
			while ((st < len) && (val[off + len - 1] <= ',')) {
			len--;
			}
			return ((st > 0) || (len < returnstr.length())) ? returnstr.substring(st, len): returnstr;
	}
	
	/**
	 * 获得虚拟部门下的人员
	 * @param deptids 部门id
	 */
	public String getVirtualResourceids(String deptids) {
		String virtualsql=" select resourceid from HrmresourceVirtual where departmentid in("+deptids+")";
		RecordSet recordSet=new RecordSet();
		recordSet.execute(virtualsql);
		String vRresourceids="";
		while(recordSet.next()){
			vRresourceids+=","+recordSet.getString("resourceid");
		}
		return vRresourceids;
	}
	
}
